unit UPrincipale;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Grids, ExtCtrls, USerpent, UFrameMenu, UFrameFin;

const CASEVIDE : TColor = clBlack;
      CORPS : TColor = clGreen;
      TETE : TColor = clOlive;
      GRENOUILLE : TColor = clLime;
      OBSTACLE : TColor = clRed;
      NIVEAUX = 1;
            
type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Jeu1: TMenuItem;
    Nouvellepartie1: TMenuItem;
    DrawGrid1: TDrawGrid;
    Timer1: TTimer;
    FrameMenu: TFrameMenu;
    Recommencer1: TMenuItem;
    Pause1: TMenuItem;
    Quitter1: TMenuItem;
    FrameFin: TFrameFin;
    procedure FormCreate(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Nouvellepartie1Click(Sender: TObject);
    procedure FrameMenuRGModeClick(Sender: TObject);
    procedure FrameMenuBoutonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Recommencer1Click(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
  private
    { Private declarations }
    procedure initialiserPartie;
    procedure creerGrenouille;
    procedure deplacement(var S:TSerpent; const dir:TDirection);
    procedure statutPartie;
    procedure perdu;
    procedure continue;
    procedure niveauSuivant;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  S: TSerpent;
  oldTete,oldQueue,newTete: TCoord;
  Score: cardinal = 0;
  ScoreMax: cardinal = 0;
  Mode: cardinal = 0;
  Niveau: cardinal = 1;
  Vie: cardinal = 7;

implementation

uses UMatrice, UNiveaux;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
   Randomize;
end;

procedure TForm1.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var couleur:TColor;
begin
   couleur := GetMatElem(ACol, ARow);
   with Drawgrid1, Canvas do begin
     Pen.Color := couleur;
     Brush.Color := couleur;
     Ellipse(Rect);
   end;
end;

procedure TForm1.Nouvellepartie1Click(Sender: TObject);
begin
   Caption := 'Snake';
   with FrameMenu do begin
      RGMode.Visible := true;
      RGNiveau.Visible := true;
      RGScore.Visible := true;
      Bouton.Visible := true;
      Visible := true;
      end;
   FrameFin.Visible := false;
   NouvellePartie1.Enabled := false;
   Recommencer1.Enabled := false;
   if Pause1.Checked then
      begin
         Pause1.Checked := false;
         Pause1.Enabled := false;
      end;
end;

procedure TForm1.FrameMenuRGModeClick(Sender: TObject);
begin
   with FrameMenu do
      if RGMode.ItemIndex = NIVEAUX then RGScore.Enabled := true
      else RGScore.Enabled := false;
end;

procedure TForm1.FrameMenuBoutonClick(Sender: TObject);
begin
   FrameMenu.Visible := false;
   Pause1.Enabled := true;
   Quitter1.Enabled := false;
   Mode := FrameMenu.RGMode.ItemIndex;
   Niveau := 1;
   ScoreMax := strtoint(FrameMenu.RGScore.Items[FrameMenu.RGScore.ItemIndex]);
   Vie := 7 - FrameMenu.RGNiveau.ItemIndex;
   initialiserPartie;
   Timer1.Interval := 125-(FrameMenu.RGNiveau.ItemIndex*25);
   Timer1.Enabled := true;
end;

procedure TForm1.initialiserPartie;
begin
   initMatrice;
   creerSerpent(S,12,13);
   setMatElem(12,13,TETE);
   setMatElem(11,13,CORPS);
   setMatElem(10,13,CORPS);
   Score := 0;
   Caption := 'Snake - Score: 0';
   if Mode = NIVEAUX then
      begin
         Caption := Caption + ' - Vie: ' + inttostr(Vie);
         if Niveau > 1 then creerNiveau(Niveau);
      end;
   creerGrenouille;
end;

procedure TForm1.creerGrenouille;
var x,y:cardinal;
begin
   x := random(NB_COLONNES);
   y := random(NB_RANGEES);
   while getMatElem(x,y) <> CASEVIDE do begin
      x := random(NB_COLONNES);
      y := random(NB_RANGEES);
      end;
   setMatElem(x,y,GRENOUILLE);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   deplacement(S,S.direction);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if Timer1.Enabled then
      case Key of
         VK_UP: deplacement(S,NORD);
         VK_RIGHT: deplacement(S,EST);
         VK_DOWN: deplacement(S,SUD);
         VK_LEFT: deplacement(S,OUEST);
         end;
end;

procedure TForm1.deplacement(var S:TSerpent; const dir:TDirection);
begin
   oldTete := getTete(S);
   oldQueue := getQueue(S);
   deplacerSerpent(S,dir);
   newTete := getTete(S);
   if (oldTete[x]<>newTete[x]) or (oldTete[y]<>newTete[y]) then statutPartie;
end;

procedure TForm1.statutPartie;
begin
   if (getMatElem(newTete[x],newTete[y]) = OBSTACLE)
      or (getMatElem(newTete[x],newTete[y]) = CORPS)
      or (newTete[x] > NB_COLONNES-1) or (newTete[y] > NB_RANGEES-1)
      or (newTete[x] < 0) or (newTete[y] < 0)
      then perdu
   else continue;
end;

procedure TForm1.perdu;
begin
   Timer1.Enabled := false;
   NouvellePartie1.Enabled := true;
   Recommencer1.Enabled := true;
   Pause1.Enabled := false;
   Quitter1.Enabled := true;
   if Mode = NIVEAUX then dec(Vie);
   if Vie = 0 then
      begin
         FrameFin.LabelResultat.Caption := 'Dsol, vous avez perdu !';
         FrameFin.Visible := true;
         Recommencer1.Enabled := false;
      end
   else showMessage('Vous avez perdu !'#13#10#10 +
      'F1 pour retourner au menu principal'#13#10#10 +
      'F2 pour ressayer'); 
end;

procedure TForm1.continue;
begin
   if getMatElem(newTete[x],newTete[y]) = GRENOUILLE then
      begin
         inc(Score);
         Caption := 'Snake - Score: ' + inttostr(Score);
         if Mode = NIVEAUX then Caption := Caption + ' - Vie: ' + inttostr(Vie);
         setMatElem(newTete[x],newTete[y],TETE);
         setMatElem(oldTete[x],oldTete[y],CORPS);
         creerGrenouille;
         DrawGrid1.Repaint;
         if (Mode = NIVEAUX) and (Score = ScoreMax) then niveauSuivant;
      end
   else
      begin
         couperQueue(S);
         setMatElem(newTete[x],newTete[y],TETE);
         setMatElem(oldTete[x],oldTete[y],CORPS);
         setMatElem(oldQueue[x],oldQueue[y],CASEVIDE);
         DrawGrid1.Repaint;
      end;
end;

procedure TForm1.niveauSuivant;
begin
   Timer1.Enabled := false;
   if Niveau = 5 then
      begin
         FrameFin.LabelResultat.Caption := 'Bravo, vous avez gagn !';
         FrameFin.Visible := true;
         NouvellePartie1.Enabled := true;
         Pause1.Enabled := false;
         Quitter1.Enabled := true;
      end
   else
      begin
         showMessage('Bravo, vous avez termin le niveau ' + inttostr(Niveau)
         + ' !'#13#10#10 + 'Appuyez sur OK pour passer au niveau suivant...');
         inc(Niveau);
         initialiserPartie;
         Timer1.Enabled := true;
      end;
end;

procedure TForm1.Recommencer1Click(Sender: TObject);
begin
   NouvellePartie1.Enabled := false;
   Recommencer1.Enabled := false;
   Pause1.Checked := false;
   Pause1.Enabled := true;
   initialiserPartie;
   Timer1.Enabled := true;
end;

procedure TForm1.Pause1Click(Sender: TObject);
begin
   if Timer1.Enabled then
      begin
         Timer1.Enabled := false;
         Pause1.Checked := true;
         NouvellePartie1.Enabled := true;
         Recommencer1.Enabled := true;
         Quitter1.Enabled := true;
      end
   else
      begin
         Pause1.Checked := false;
         NouvellePartie1.Enabled := false;
         Recommencer1.Enabled := false;
         Quitter1.Enabled := false;
         Timer1.Enabled := true;
      end;
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
   Close;
end;

end.
